searchNodes=[{"doc":"Generates a .formatter.exs from a list of extensions, and writes it.","ref":"Mix.Tasks.Ash.Formatter.html","title":"Mix.Tasks.Ash.Formatter","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Ash.Formatter.html#run/1","title":"Mix.Tasks.Ash.Formatter.run/1","type":"function"},{"doc":"Ash FrameworkALPHA NOTICEAsh is in alpha. The package version is 1.0.0+, and most of the time that means stable, but in this case it does not. The 2.0 release will be the stable release.Quick LinksResource DSL DocumentationApi DSL DocumentationApi interface documentationQuery DocumentationChangeset DocumentationGuidesIntroductionTraditional MVC Frameworks (Rails, Django, .Net, Phoenix, etc) leave it up to the user to build the glue between requests for data (HTTP requests in various forms as well as server-side domain logic) and their respective ORMs. In that space, there is an incredible amount of boilerplate code that must get written from scratch for each application (authentication, authorization, sorting, filtering, sideloading relationships, serialization, etc).Ash is an opinionated yet configurable framework designed to reduce boilerplate in an Elixir application. Ash does this by providing a layer of abstraction over your system's data layer(s) with Resources. It is designed to be used in conjunction with a phoenix application, or on its own.To riff on a famous JRR Tolkien quote, a Resourceis &quot;One Interface to rule them all, One Interface to find them&quot; and will become an indispensable place to define contracts for interacting with data throughout your application.To start using Ash, first declare your Resources using the Ash Resource DSL. You could technically stop there, and just leverage the Ash Elixir API to avoid writing boilerplate. More likely, you would use extensions like Ash.JsonApi or Ash.GraphQL with Phoenix to add external interfaces to those resources without having to write any extra code at all.Ash is an open-source project and draws inspiration from similar ideas in other frameworks and concepts. The goal of Ash is to lower the barrier to adopting and using Elixir and Phoenix, and in doing so help these amazing communities attract new developers, projects, and companies.Example Resourcedefmodule Post do use Ash.Resource actions do read :default create :default end attributes do attribute :name, :string end relationships do belongs_to :author, Author end endSee the getting started guide for more information.For those looking to add ash extensions:see Ash.Dsl.Extension for adding configuration.If you are looking to write a new data source, also see the Ash.DataLayer documentation.If you are looking to write a new authorizer, see Ash.AuthorizerIf you are looking to write a &quot;front end&quot;, something powered by Ash resources, a guide on building those kinds of tools is in the works.","ref":"Ash.html","title":"Ash","type":"module"},{"doc":"Returns all extensions of a resource or api","ref":"Ash.html#extensions/1","title":"Ash.extensions/1","type":"function"},{"doc":"","ref":"Ash.html#implements_behaviour?/2","title":"Ash.implements_behaviour?/2","type":"function"},{"doc":"","ref":"Ash.html#t:action/0","title":"Ash.action/0","type":"type"},{"doc":"","ref":"Ash.html#t:action_type/0","title":"Ash.action_type/0","type":"type"},{"doc":"","ref":"Ash.html#t:actor/0","title":"Ash.actor/0","type":"type"},{"doc":"","ref":"Ash.html#t:aggregate/0","title":"Ash.aggregate/0","type":"type"},{"doc":"","ref":"Ash.html#t:aggregate_kind/0","title":"Ash.aggregate_kind/0","type":"type"},{"doc":"","ref":"Ash.html#t:api/0","title":"Ash.api/0","type":"type"},{"doc":"","ref":"Ash.html#t:attribute/0","title":"Ash.attribute/0","type":"type"},{"doc":"","ref":"Ash.html#t:cardinality_many_relationship/0","title":"Ash.cardinality_many_relationship/0","type":"type"},{"doc":"","ref":"Ash.html#t:cardinality_one_relationship/0","title":"Ash.cardinality_one_relationship/0","type":"type"},{"doc":"","ref":"Ash.html#t:changeset/0","title":"Ash.changeset/0","type":"type"},{"doc":"","ref":"Ash.html#t:data_layer/0","title":"Ash.data_layer/0","type":"type"},{"doc":"","ref":"Ash.html#t:data_layer_query/0","title":"Ash.data_layer_query/0","type":"type"},{"doc":"","ref":"Ash.html#t:error/0","title":"Ash.error/0","type":"type"},{"doc":"","ref":"Ash.html#t:filter/0","title":"Ash.filter/0","type":"type"},{"doc":"","ref":"Ash.html#t:params/0","title":"Ash.params/0","type":"type"},{"doc":"","ref":"Ash.html#t:primary_key/0","title":"Ash.primary_key/0","type":"type"},{"doc":"","ref":"Ash.html#t:query/0","title":"Ash.query/0","type":"type"},{"doc":"","ref":"Ash.html#t:record/0","title":"Ash.record/0","type":"type"},{"doc":"","ref":"Ash.html#t:relationship/0","title":"Ash.relationship/0","type":"type"},{"doc":"","ref":"Ash.html#t:relationship_cardinality/0","title":"Ash.relationship_cardinality/0","type":"type"},{"doc":"","ref":"Ash.html#t:resource/0","title":"Ash.resource/0","type":"type"},{"doc":"","ref":"Ash.html#t:side_loads/0","title":"Ash.side_loads/0","type":"type"},{"doc":"","ref":"Ash.html#t:sort/0","title":"Ash.sort/0","type":"type"},{"doc":"","ref":"Ash.html#t:validation/0","title":"Ash.validation/0","type":"type"},{"doc":"An Api allows you to interact with your resources, and holds non-resource-specific configuration.Your Api can also house config that is not resource specific. Defining a resource won't do much for you. Once you have some resources defined, you include them in an Api like so:defmodule MyApp.Api do use Ash.Api resources do resource OneResource resource SecondResource endThen you can interact through that Api with the actions that those resources expose. For example: MyApp.Api.create(changeset), or MyApp.Api.read(query). Corresponding actions must be defined in your resources in order to call them through the Api.","ref":"Ash.Api.html","title":"Ash.Api","type":"behaviour"},{"doc":"Create a record.:upsert? - If a conflict is found based on the primary key, the record is updated in the database (requires upsert support) The default value is false.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:create/2","title":"Ash.Api.create/2","type":"callback"},{"doc":"Create a record. See create/2 for more information.:upsert? - If a conflict is found based on the primary key, the record is updated in the database (requires upsert support) The default value is false.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:create!/2","title":"Ash.Api.create!/2","type":"callback"},{"doc":"Destroy a record.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:destroy/2","title":"Ash.Api.destroy/2","type":"callback"},{"doc":"Destroy a record. See destroy/2 for more information.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:destroy!/2","title":"Ash.Api.destroy!/2","type":"callback"},{"doc":"Get a record by a primary key.For a resource with a composite primary key, pass a keyword list, e.g MyApi.get(MyResource, first_key: 1, second_key: 2):load - Fields or relationships to load in the query. See Ash.Query.load/2:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:get/3","title":"Ash.Api.get/3","type":"callback"},{"doc":"Get a record by a primary key. See get/3 for more.:load - Fields or relationships to load in the query. See Ash.Query.load/2:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:get!/3","title":"Ash.Api.get!/3","type":"callback"},{"doc":"Load fields or relationships on already fetched records.Accepts a list of non-loaded fields and loads them on the provided records or a query, in which case the loaded fields of the query are used. Relationship loads can be nested, for example: MyApi.load(record, [posts: [:comments]]). See Ash.Query.side_load/2 for more information on specifically loading relationships.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:load/2","title":"Ash.Api.load/2","type":"callback"},{"doc":"Load fields or relationships on already fetched records. See load/2 for more information.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:load!/2","title":"Ash.Api.load!/2","type":"callback"},{"doc":"Run a query on a resource.For more information, on building a query, see Ash.Query.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:read/2","title":"Ash.Api.read/2","type":"callback"},{"doc":"Run an ash query. See read/2 for more.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:read!/2","title":"Ash.Api.read!/2","type":"callback"},{"doc":"Refetches a record by primary key.","ref":"Ash.Api.html#c:reload/1","title":"Ash.Api.reload/1","type":"callback"},{"doc":"Refetches a record by primary key. See reload/1 for more.","ref":"Ash.Api.html#c:reload!/2","title":"Ash.Api.reload!/2","type":"callback"},{"doc":"","ref":"Ash.Api.html#resource/2","title":"Ash.Api.resource/2","type":"function"},{"doc":"","ref":"Ash.Api.html#resources/1","title":"Ash.Api.resources/1","type":"function"},{"doc":"Update a record.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:update/2","title":"Ash.Api.update/2","type":"callback"},{"doc":"Update a record. See update/2 for more information.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:update!/2","title":"Ash.Api.update!/2","type":"callback"},{"doc":"Changesets are used to create and update data in Ash.Create a changeset with create/2 or update/2, and alter the attributes and relationships using the functions provided in this module. Nothing in this module actually incurs changes in a data layer. To commit a changeset, see Ash.Api.create/2 and Ash.Api.update/2.Primary KeysFor relationship manipulation using append_to_relationship/3, remove_from_relationship/3 and replace_relationship/3 there are three types that can be used for primary keys:1.) An instance of the resource in question.2.) If the primary key is just a single field, i.e :id, then a single value, i.e 13.) A map of keys to values representing the primary key, i.e %{id: 1} or %{id: 1, org_id: 2}Join AttributesFor many to many relationships, the attributes on a join relationship may be set while relating items by passing a tuple of the primary key and the changes to be applied. This is done via upserts, so update validations on the join resource are not applied, but create validations are.For example:Ash.Changeset.replace_relationship(changeset, :linked_tickets, [ {1, %{link_type: &quot;blocking&quot;}}, {a_ticket, %{link_type: &quot;caused_by&quot;}}, {%{id: 2}, %{link_type: &quot;related_to&quot;}} ])","ref":"Ash.Changeset.html","title":"Ash.Changeset","type":"module"},{"doc":"Adds an error to the changesets errors list, and marks the change as valid?: false","ref":"Ash.Changeset.html#add_error/2","title":"Ash.Changeset.add_error/2","type":"function"},{"doc":"Adds an after_action hook to the changeset.","ref":"Ash.Changeset.html#after_action/2","title":"Ash.Changeset.after_action/2","type":"function"},{"doc":"Appends a record of list of records to a relationship. Stacks with previous removals/additions.Accepts a primary key or a list of primary keys. See the section on &quot;Primary Keys&quot; in the module documentation for more.For many to many relationships, accepts changes for any join_attributes configured on the resource. See the section on &quot;Join Attributes&quot; in the module documentation for more.Cannot be used with belongs_to or has_one relationships. See replace_relationship/3 for manipulating belongs_to and has_one relationships.","ref":"Ash.Changeset.html#append_to_relationship/3","title":"Ash.Changeset.append_to_relationship/3","type":"function"},{"doc":"Returns the original data with attribute changes merged.","ref":"Ash.Changeset.html#apply_attributes/1","title":"Ash.Changeset.apply_attributes/1","type":"function"},{"doc":"Adds a before_action hook to the changeset.","ref":"Ash.Changeset.html#before_action/2","title":"Ash.Changeset.before_action/2","type":"function"},{"doc":"Adds a change to the changeset, unless the value matches the existing value","ref":"Ash.Changeset.html#change_attribute/3","title":"Ash.Changeset.change_attribute/3","type":"function"},{"doc":"Calls change_attribute/3 for each key/value pair provided","ref":"Ash.Changeset.html#change_attributes/2","title":"Ash.Changeset.change_attributes/2","type":"function"},{"doc":"Change an attribute only if is not currently being changed","ref":"Ash.Changeset.html#change_new_attribute/3","title":"Ash.Changeset.change_new_attribute/3","type":"function"},{"doc":"Change an attribute if is not currently being changed, by calling the provided functionUse this if you want to only perform some expensive calculation for an attribute value only if there isn't already a change for that attribute","ref":"Ash.Changeset.html#change_new_attribute_lazy/3","title":"Ash.Changeset.change_new_attribute_lazy/3","type":"function"},{"doc":"Returns true if an attribute exists in the changes","ref":"Ash.Changeset.html#changing_attribute?/2","title":"Ash.Changeset.changing_attribute?/2","type":"function"},{"doc":"Gets the new value for an attribute, or :error if it is not being changed","ref":"Ash.Changeset.html#fetch_change/2","title":"Ash.Changeset.fetch_change/2","type":"function"},{"doc":"Changes an attribute even if it isn't writable","ref":"Ash.Changeset.html#force_change_attribute/3","title":"Ash.Changeset.force_change_attribute/3","type":"function"},{"doc":"Calls force_change_attribute/3 for each key/value pair provided","ref":"Ash.Changeset.html#force_change_attributes/2","title":"Ash.Changeset.force_change_attributes/2","type":"function"},{"doc":"Gets the changing value or the original value of an attribute","ref":"Ash.Changeset.html#get_attribute/2","title":"Ash.Changeset.get_attribute/2","type":"function"},{"doc":"Gets the original value for an attribute","ref":"Ash.Changeset.html#get_data/2","title":"Ash.Changeset.get_data/2","type":"function"},{"doc":"Return a changeset over a resource or a record","ref":"Ash.Changeset.html#new/2","title":"Ash.Changeset.new/2","type":"function"},{"doc":"Removes a record of list of records to a relationship. Stacks with previous removals/additions.Accepts a primary key or a list of primary keys. See the section on &quot;Primary Keys&quot; in the module documentation for more.Cannot be used with belongs_to or has_one relationships. See replace_relationship/3 for manipulating those relationships.","ref":"Ash.Changeset.html#remove_from_relationship/3","title":"Ash.Changeset.remove_from_relationship/3","type":"function"},{"doc":"Replaces the value of a relationship. Any previous additions/removals are cleared.Accepts a primary key or a list of primary keys. See the section on &quot;Primary Keys&quot; in the module documentation for more.For many to many relationships, accepts changes for any join_attributes configured on the resource. See the section on &quot;Join Attributes&quot; in the module documentation for more.For a has_many or many_to_many relationship, this means removing any currently related records that are not present in the replacement list, and creating any that do not exist in the data layer.For a belongs_to or has_one, replace with a nil value to unset a relationship.","ref":"Ash.Changeset.html#replace_relationship/3","title":"Ash.Changeset.replace_relationship/3","type":"function"},{"doc":"Wraps a function in the before/after action hooks of a changeset.The function takes a changeset and if it returns {:ok, result}, the result will be passed through the after action hooks.","ref":"Ash.Changeset.html#with_hooks/2","title":"Ash.Changeset.with_hooks/2","type":"function"},{"doc":"","ref":"Ash.Changeset.html#t:t/0","title":"Ash.Changeset.t/0","type":"type"},{"doc":"Utilties around constructing/manipulating ash queries.Ash queries are used for read actions and side loads, and ultimately map to queries to a resource's data layer.","ref":"Ash.Query.html","title":"Ash.Query","type":"module"},{"doc":"Adds an aggregation to the query.Aggregations are made available on the aggregates field of the records returnedThe only aggregate available currently is a count aggregate. They filter option accepts either a filter or a keyword list of options to supply to build a limiting query for that aggregate. However, currently only filters are accepted.","ref":"Ash.Query.html#aggregate/5","title":"Ash.Query.aggregate/5","type":"function"},{"doc":"","ref":"Ash.Query.html#build/3","title":"Ash.Query.build/3","type":"function"},{"doc":"","ref":"Ash.Query.html#do_validate_side_load/3","title":"Ash.Query.do_validate_side_load/3","type":"function"},{"doc":"","ref":"Ash.Query.html#filter/2","title":"Ash.Query.filter/2","type":"function"},{"doc":"Limit the results returned from the query","ref":"Ash.Query.html#limit/2","title":"Ash.Query.limit/2","type":"function"},{"doc":"","ref":"Ash.Query.html#load/2","title":"Ash.Query.load/2","type":"function"},{"doc":"Create a new query.","ref":"Ash.Query.html#new/2","title":"Ash.Query.new/2","type":"function"},{"doc":"Skip the first n records","ref":"Ash.Query.html#offset/2","title":"Ash.Query.offset/2","type":"function"},{"doc":"Set the query's api, and any side loaded query's api","ref":"Ash.Query.html#set_api/2","title":"Ash.Query.set_api/2","type":"function"},{"doc":"Side loads related entities","ref":"Ash.Query.html#side_load/2","title":"Ash.Query.side_load/2","type":"function"},{"doc":"","ref":"Ash.Query.html#sort/2","title":"Ash.Query.sort/2","type":"function"},{"doc":"","ref":"Ash.Query.html#unload/2","title":"Ash.Query.unload/2","type":"function"},{"doc":"","ref":"Ash.Query.html#unset/2","title":"Ash.Query.unset/2","type":"function"},{"doc":"","ref":"Ash.Query.html#validate_side_load/3","title":"Ash.Query.validate_side_load/3","type":"function"},{"doc":"","ref":"Ash.Query.html#t:t/0","title":"Ash.Query.t/0","type":"type"},{"doc":"This behaviour is a superset of the Ecto.Type behavior, that also contains api level information, like what kinds of filters are allowed. Eventually, this may be used for composite types or serialization.Much better to use Ash.Type than to say @behaviour Ash.Type and define everything yourself.Built in types:term - Ash.Type.Term:string - Ash.Type.String:integer - Ash.Type.Integer:boolean - Ash.Type.Boolean:uuid - Ash.Type.UUID:date - Ash.Type.Date:utc_datetime - Ash.Type.UtcDatetimeComposite TypesCurrently, the only composite type supported is a list type, specified via: {:array, Type}. The constraints available are::items - Constraints for the elements of the list. See the contained type's docs for more.:min_length - A minimum length for the items:max_length - A maximum length for the items:nil_items? - Whether or not the list can contain nil items The default value is true.","ref":"Ash.Type.html","title":"Ash.Type","type":"behaviour"},{"doc":"","ref":"Ash.Type.html#c:apply_constraints/2","title":"Ash.Type.apply_constraints/2","type":"callback"},{"doc":"Confirms if a casted value matches the provided constraints.","ref":"Ash.Type.html#apply_constraints/3","title":"Ash.Type.apply_constraints/3","type":"function"},{"doc":"Returns true if the value is a builtin type or adopts the Ash.Type behaviour","ref":"Ash.Type.html#ash_type?/1","title":"Ash.Type.ash_type?/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:cast_input/1","title":"Ash.Type.cast_input/1","type":"callback"},{"doc":"Casts input (e.g. unknown) data to an instance of the type, or errorsMaps to Ecto.Type.cast/2","ref":"Ash.Type.html#cast_input/2","title":"Ash.Type.cast_input/2","type":"function"},{"doc":"","ref":"Ash.Type.html#c:cast_stored/1","title":"Ash.Type.cast_stored/1","type":"callback"},{"doc":"Casts a value from the data store to an instance of the type, or errorsMaps to Ecto.Type.load/2","ref":"Ash.Type.html#cast_stored/2","title":"Ash.Type.cast_stored/2","type":"function"},{"doc":"","ref":"Ash.Type.html#c:constraints/0","title":"Ash.Type.constraints/0","type":"callback"},{"doc":"","ref":"Ash.Type.html#constraints/1","title":"Ash.Type.constraints/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:dump_to_native/1","title":"Ash.Type.dump_to_native/1","type":"callback"},{"doc":"Casts a value from the Elixir type to a value that the data store can persistMaps to Ecto.Type.dump/2","ref":"Ash.Type.html#dump_to_native/2","title":"Ash.Type.dump_to_native/2","type":"function"},{"doc":"","ref":"Ash.Type.html#c:ecto_type/0","title":"Ash.Type.ecto_type/0","type":"callback"},{"doc":"Returns the ecto compatible type for an Ash.Type.If you use Ash.Type, this is created for you. For builtin types this may return a corresponding ecto builtin type (atom)","ref":"Ash.Type.html#ecto_type/1","title":"Ash.Type.ecto_type/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:equal?/2","title":"Ash.Type.equal?/2","type":"callback"},{"doc":"Determines if two values of a given type are equal.Maps to Ecto.Type.equal?/3","ref":"Ash.Type.html#equal?/3","title":"Ash.Type.equal?/3","type":"function"},{"doc":"","ref":"Ash.Type.html#get_type/1","title":"Ash.Type.get_type/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:storage_type/0","title":"Ash.Type.storage_type/0","type":"callback"},{"doc":"Returns the underlying storage type (the underlying type of the ecto type of the ash type)","ref":"Ash.Type.html#storage_type/1","title":"Ash.Type.storage_type/1","type":"function"},{"doc":"","ref":"Ash.Type.html#t:constraints/0","title":"Ash.Type.constraints/0","type":"type"},{"doc":"","ref":"Ash.Type.html#t:t/0","title":"Ash.Type.t/0","type":"type"},{"doc":"Represents a boolean.A builtin type that can be referenced via :boolean","ref":"Ash.Type.Boolean.html","title":"Ash.Type.Boolean","type":"module"},{"doc":"Represents a date in the databaseA builtin type that can be referenced via :date","ref":"Ash.Type.Date.html","title":"Ash.Type.Date","type":"module"},{"doc":"Represents a simple integerA builtin type that can be referenced via :integerConstraints:max - Enforces a maximum on the value:min - Enforces a minimum on the value","ref":"Ash.Type.Integer.html","title":"Ash.Type.Integer","type":"module"},{"doc":"Stores a string in the databaseA builtin type that can be referenced via :stringConstraints:max_length - Enforces a maximum length on the value:min_length - Enforces a minimum length on the value:match - Enforces that the string matches a passed in regex","ref":"Ash.Type.String.html","title":"Ash.Type.String","type":"module"},{"doc":"","ref":"Ash.Type.String.html#match/1","title":"Ash.Type.String.match/1","type":"function"},{"doc":"Represents a raw elixir term in the databaseA builtin type that can be referenced via :string","ref":"Ash.Type.Term.html","title":"Ash.Type.Term","type":"module"},{"doc":"Represents a UUID.A builtin type that can be referenced via :utc_datetime","ref":"Ash.Type.UUID.html","title":"Ash.Type.UUID","type":"module"},{"doc":"Represents a utc datetimeA builtin type that can be referenced via :utc_datetime","ref":"Ash.Type.UtcDatetime.html","title":"Ash.Type.UtcDatetime","type":"module"},{"doc":"The interface for being an ash data layer.This is a large behaviour, and this capability is not complete, but the idea is to have a large amount of optional callbacks, and use the can?/2 callback to ensure that the engine only ever tries to interact with the data layer in ways that it supports.","ref":"Ash.DataLayer.html","title":"Ash.DataLayer","type":"behaviour"},{"doc":"","ref":"Ash.DataLayer.html#add_aggregate/3","title":"Ash.DataLayer.add_aggregate/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:add_aggregate/3","title":"Ash.DataLayer.add_aggregate/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#can?/2","title":"Ash.DataLayer.can?/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:can?/2","title":"Ash.DataLayer.can?/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#create/2","title":"Ash.DataLayer.create/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:create/2","title":"Ash.DataLayer.create/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#custom_filters/1","title":"Ash.DataLayer.custom_filters/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:custom_filters/1","title":"Ash.DataLayer.custom_filters/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#c:destroy/1","title":"Ash.DataLayer.destroy/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#filter/3","title":"Ash.DataLayer.filter/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:filter/3","title":"Ash.DataLayer.filter/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#c:in_transaction?/1","title":"Ash.DataLayer.in_transaction?/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#limit/3","title":"Ash.DataLayer.limit/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:limit/3","title":"Ash.DataLayer.limit/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#offset/3","title":"Ash.DataLayer.offset/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:offset/3","title":"Ash.DataLayer.offset/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#resource_to_query/1","title":"Ash.DataLayer.resource_to_query/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:resource_to_query/1","title":"Ash.DataLayer.resource_to_query/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#c:rollback/2","title":"Ash.DataLayer.rollback/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#run_query/2","title":"Ash.DataLayer.run_query/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:run_query/2","title":"Ash.DataLayer.run_query/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#sort/3","title":"Ash.DataLayer.sort/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:sort/3","title":"Ash.DataLayer.sort/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#source/1","title":"Ash.DataLayer.source/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:source/1","title":"Ash.DataLayer.source/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#transact/2","title":"Ash.DataLayer.transact/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:transaction/2","title":"Ash.DataLayer.transaction/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#update/2","title":"Ash.DataLayer.update/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:update/2","title":"Ash.DataLayer.update/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#upsert/2","title":"Ash.DataLayer.upsert/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:upsert/2","title":"Ash.DataLayer.upsert/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#t:feature/0","title":"Ash.DataLayer.feature/0","type":"type"},{"doc":"An ETS (Erlang Term Storage) backed Ash Datalayer, for testing.This is used for testing. Do not use this data layer in production","ref":"Ash.DataLayer.Ets.html","title":"Ash.DataLayer.Ets","type":"module"},{"doc":"A section for configuring the ets data layerOptions:private? - The default value is false.","ref":"Ash.DataLayer.Ets.html#ets/1","title":"Ash.DataLayer.Ets.ets/1","type":"macro"},{"doc":"","ref":"Ash.DataLayer.Ets.html#filter_matches/2","title":"Ash.DataLayer.Ets.filter_matches/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.Ets.html#private?/1","title":"Ash.DataLayer.Ets.private?/1","type":"function"},{"doc":"An Mnesia backed Ash Datalayer.In your application intialization, you will need to call Mnesia.create_schema([node()]).Additionally, you will want to create your mnesia tables there.This data layer is extremely unoptimized, fetching all records from a table and filtering them in place. This is primarily used for testing the behavior of data layers in Ash. If it was improved, it could be a viable data layer.","ref":"Ash.DataLayer.Mnesia.html","title":"Ash.DataLayer.Mnesia","type":"module"},{"doc":"A section for configuring the mnesia data layerOptions:table - The table name to use, defaults to the name of the resource","ref":"Ash.DataLayer.Mnesia.html#mnesia/1","title":"Ash.DataLayer.Mnesia.mnesia/1","type":"macro"},{"doc":"","ref":"Ash.DataLayer.Mnesia.html#start/1","title":"Ash.DataLayer.Mnesia.start/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.Mnesia.html#table/1","title":"Ash.DataLayer.Mnesia.table/1","type":"function"},{"doc":"The interface for an ash authorizerThese will typically be implemented by an extension, but a custom one can be implemented by defining a module that adopts this behaviour and using @authorizers YourAuthorizer to your resource.","ref":"Ash.Authorizer.html","title":"Ash.Authorizer","type":"behaviour"},{"doc":"","ref":"Ash.Authorizer.html#c:check/2","title":"Ash.Authorizer.check/2","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#check/3","title":"Ash.Authorizer.check/3","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:check_context/1","title":"Ash.Authorizer.check_context/1","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#check_context/2","title":"Ash.Authorizer.check_context/2","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:initial_state/4","title":"Ash.Authorizer.initial_state/4","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#initial_state/5","title":"Ash.Authorizer.initial_state/5","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:strict_check/2","title":"Ash.Authorizer.strict_check/2","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#strict_check/3","title":"Ash.Authorizer.strict_check/3","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:strict_check_context/1","title":"Ash.Authorizer.strict_check_context/1","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#strict_check_context/2","title":"Ash.Authorizer.strict_check_context/2","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#t:context/0","title":"Ash.Authorizer.context/0","type":"type"},{"doc":"","ref":"Ash.Authorizer.html#t:state/0","title":"Ash.Authorizer.state/0","type":"type"},{"doc":"Declares a DSL entity.A dsl entity represents a dsl constructor who's resulting value is a struct. This lets the user create complex objects with arbitrary(mostly) validation rules.The lifecycle of creating entities is complex, happening as Elixir is compiling the modules in question. Some of the patterns around validating/transforming entities have not yet solidified. If you aren't careful and don't follow the guidelines listed here, you can have subtle and strange bugs during compilation. Anything not isolated to simple value validations should be done in transformers. See Ash.Dsl.Transformer.An entity has a target indicating which struct will ultimately be built. An entity also has a schema. This schema is used for documentation, and the options are validated against it before continuing on with the DSL.To create positional arguments to the builder, use args. The values provided to args need to be in the provided schema as well. They will be positional arguments in the same order that they are provided in the args key.auto_set_fields will set the provided values into the produced struct (they do not need to be included in the schema).transform is a function that takes a created struct and can alter it. This happens immediately after handling the DSL options, and can be useful for setting field values on a struct based on other values in that struct. If you need things that aren't contained in that struct, use an Ash.Dsl.Transformer.entities allows you to specify a keyword list of nested entities. Nested entities are stored on the struct in the corresponding key, and are used in the same way entities are otherwise.For a full example, see Ash.Dsl.Extension.","ref":"Ash.Dsl.Entity.html","title":"Ash.Dsl.Entity","type":"module"},{"doc":"","ref":"Ash.Dsl.Entity.html#build/3","title":"Ash.Dsl.Entity.build/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Entity.html#describe/2","title":"Ash.Dsl.Entity.describe/2","type":"function"},{"doc":"","ref":"Ash.Dsl.Entity.html#t:t/0","title":"Ash.Dsl.Entity.t/0","type":"type"},{"doc":"An extension to the Ash DSL.This allows configuring custom DSL components, whos configurations can then be read back.The example at the bottom shows how you might build a (not very contextually relevant) DSL extension that would be used like so:defmodule MyApp.MyResource do use Ash.Resource, extensions: [MyApp.CarExtension] cars do car :mazda, &quot;6&quot;, trim: :touring car :toyota, &quot;corolla&quot; end endFor (a not very contextually relevant) example:defmodule MyApp.CarExtension do @car_schema [ make: [ type: :atom, required: true, doc: &quot;The make of the car&quot; ], model: [ type: :atom, required: true, doc: &quot;The model of the car&quot; ], type: [ type: :atom, required: true, doc: &quot;The type of the car&quot;, default: :sedan ] ] @car %Ash.Dsl.Entity{ name: :car, describe: &quot;Adds a car&quot;, examples: [ &quot;car :mazda, &quot;6&quot;&quot; ], target: MyApp.Car, args: [:make, :model], schema: @car_schema } @cars %Ash.Dsl.Section{ name: :cars, # The DSL constructor will be `cars` describe: &quot;&quot;&quot; Configure what cars are available. More, deeper explanation. Always have a short one liner explanation, an empty line, and then a longer explanation. &quot;&quot;&quot;, entities: [ @car # See `Ash.Dsl.Entity` docs ], schema: [ default_manufacturer: [ type: :atom, doc: &quot;The default manufacturer&quot; ] ] } use Ash.Dsl.Extension, sections: [@cars] endOften, we will need to do complex validation/validate based on the configuration of other resources. Due to the nature of building compile time DSLs, there are many restrictions around that process. To support these complex use cases, extensions can include transformers which can validate/transform the DSL state after all basic sections/entities have been created. See Ash.Dsl.Transformer for more information. Transformers are provided as an option to use, like so:use Ash.Dsl.Extension, sections: [@cars], transformers: [ MyApp.Transformers.ValidateNoOverlappingMakesAndModels ]To expose the configuration of your DSL, define functions that use the helpers like get_entities/2 and get_opt/3. For example:defmodule MyApp.Cars do def cars(resource) do Ash.Dsl.Extension.get_entities(resource, [:cars]) end end MyApp.Cars.cars(MyResource) # [%MyApp.Car{...}, %MyApp.Car{...}]","ref":"Ash.Dsl.Extension.html","title":"Ash.Dsl.Extension","type":"behaviour"},{"doc":"Get the entities configured for a given section","ref":"Ash.Dsl.Extension.html#get_entities/2","title":"Ash.Dsl.Extension.get_entities/2","type":"function"},{"doc":"Get an option value for a section at a given path.Checks to see if it has been overridden via configuration.","ref":"Ash.Dsl.Extension.html#get_opt/5","title":"Ash.Dsl.Extension.get_opt/5","type":"function"},{"doc":"","ref":"Ash.Dsl.Extension.html#get_opt_config/3","title":"Ash.Dsl.Extension.get_opt_config/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Extension.html#import_mods/1","title":"Ash.Dsl.Extension.import_mods/1","type":"macro"},{"doc":"","ref":"Ash.Dsl.Extension.html#load/0","title":"Ash.Dsl.Extension.load/0","type":"macro"},{"doc":"","ref":"Ash.Dsl.Extension.html#run_transformers/3","title":"Ash.Dsl.Extension.run_transformers/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Extension.html#c:sections/0","title":"Ash.Dsl.Extension.sections/0","type":"callback"},{"doc":"","ref":"Ash.Dsl.Extension.html#c:transformers/0","title":"Ash.Dsl.Extension.transformers/0","type":"callback"},{"doc":"","ref":"Ash.Dsl.Extension.html#unimport_mods/1","title":"Ash.Dsl.Extension.unimport_mods/1","type":"macro"},{"doc":"Declares a DSL section.A dsl section allows you to organize related configurations. All extensions configure sections, they cannot add DSL builders to the top level. This keeps things organized, and concerns separated.A section may have nested sections, which will be configured the same as other sections. Getting the options/entities of a section is done by providing a path, so you would use the nested path to retrieve that configuration. See Ash.Dsl.Extension.get_entities/2 and Ash.Dsl.Extension.get_opt/4.A section may have entities, which are constructors that produce instances of structs. For more on entities, see Ash.Dsl.Entity.A section may also have a schema, which is a NimbleOptions schema. Ash will produce builders for those options, so that they may be configured. They are retrived with Ash.Dsl.Extension.get_opt/4.For a full example, see Ash.Dsl.Extension.","ref":"Ash.Dsl.Section.html","title":"Ash.Dsl.Section","type":"module"},{"doc":"","ref":"Ash.Dsl.Section.html#describe/3","title":"Ash.Dsl.Section.describe/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Section.html#t:t/0","title":"Ash.Dsl.Section.t/0","type":"type"},{"doc":"A transformer manipulates and/or validates the entire DSL state of a resource.It's transform/2 takes a map, which is just the values/configurations at each point of the DSL. Don't manipulate it directly, if possible, instead use functions like get_entities/3 and replace_entity/5 to manipulate it.Use the after?/1 and before?/1 callbacks to ensure that your transformer runs either before or after some other transformer.The pattern for requesting information from other modules that use the DSL and are also currently compiling has not yet been determined. If you have that requirement you will need extra utilities to ensure that some other DSL based module has either completed or reached a certain point in its transformers. These utilities have not yet been written.","ref":"Ash.Dsl.Transformer.html","title":"Ash.Dsl.Transformer","type":"behaviour"},{"doc":"","ref":"Ash.Dsl.Transformer.html#add_entity/3","title":"Ash.Dsl.Transformer.add_entity/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#c:after?/1","title":"Ash.Dsl.Transformer.after?/1","type":"callback"},{"doc":"","ref":"Ash.Dsl.Transformer.html#c:before?/1","title":"Ash.Dsl.Transformer.before?/1","type":"callback"},{"doc":"","ref":"Ash.Dsl.Transformer.html#build_before_after_list/3","title":"Ash.Dsl.Transformer.build_before_after_list/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#build_entity/4","title":"Ash.Dsl.Transformer.build_entity/4","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#compare/2","title":"Ash.Dsl.Transformer.compare/2","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#get_entities/2","title":"Ash.Dsl.Transformer.get_entities/2","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#get_option/3","title":"Ash.Dsl.Transformer.get_option/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#persist/3","title":"Ash.Dsl.Transformer.persist/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#replace_entity/4","title":"Ash.Dsl.Transformer.replace_entity/4","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#sort/1","title":"Ash.Dsl.Transformer.sort/1","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#c:transform/2","title":"Ash.Dsl.Transformer.transform/2","type":"callback"},{"doc":"The built in resource DSL. The four core DSL components of a resource are:attributes - attributes/1relationships - relationships/1actions - actions/1validations - validations/1aggregates - aggregates/1","ref":"Ash.Resource.Dsl.html","title":"Ash.Resource.Dsl","type":"module"},{"doc":"A section for declaring resource actions.All manipulation of data through the underlying data layer happens through actions. There are four types of action: create, read, update, and destroy. You may recognize these from the acronym CRUD. You can have multiple actions of the same type, as long as they have different names. This is the primary mechanism for customizing your resources to conform to your business logic. It is normal and expected to have multiple actions of each type in a large application.If you have multiple actions of the same type, one of them must be designated as the primary action for that type, via: primary?: true. This tells the ash what to do if an action of that type is requested, but no specific action name is given.Constructorscreate - Ash.Resource.Dsl.Createread - Ash.Resource.Dsl.Readupdate - Ash.Resource.Dsl.Updatedestroy - Ash.Resource.Dsl.Destroy","ref":"Ash.Resource.Dsl.html#actions/1","title":"Ash.Resource.Dsl.actions/1","type":"macro"},{"doc":"Declare named aggregates on the resource.These are aggregates that can be loaded only by name using Ash.Query.load/2. They are also available as top level fields on the resource.Constructorscount - Ash.Resource.Dsl.Count","ref":"Ash.Resource.Dsl.html#aggregates/1","title":"Ash.Resource.Dsl.aggregates/1","type":"macro"},{"doc":"A section for declaring attributes on the resource.Attributes are fields on an instance of a resource. The two required pieces of knowledge are the field name, and the type.Constructorsattribute - Ash.Resource.Dsl.Attributecreate_timestamp - Ash.Resource.Dsl.CreateTimestampupdate_timestamp - Ash.Resource.Dsl.UpdateTimestamp","ref":"Ash.Resource.Dsl.html#attributes/1","title":"Ash.Resource.Dsl.attributes/1","type":"macro"},{"doc":"A section for declaring relationships on the resource.Relationships are a core component of resource oriented design. Many components of Ash will use these relationships. A simple use case is side_loading (done via the Ash.Query.side_load/2).Constructorshas_one - Ash.Resource.Dsl.HasOnehas_many - Ash.Resource.Dsl.HasManymany_to_many - Ash.Resource.Dsl.ManyToManybelongs_to - Ash.Resource.Dsl.BelongsTo","ref":"Ash.Resource.Dsl.html#relationships/1","title":"Ash.Resource.Dsl.relationships/1","type":"macro"},{"doc":"Resource-wide configurationOptions:description","ref":"Ash.Resource.Dsl.html#resource/1","title":"Ash.Resource.Dsl.resource/1","type":"macro"},{"doc":"Declare validations prior to performing actions against the resourceConstructorsvalidate - Ash.Resource.Dsl.Validate","ref":"Ash.Resource.Dsl.html#validations/1","title":"Ash.Resource.Dsl.validations/1","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.Attribute.html","title":"Ash.Resource.Dsl.Attribute","type":"module"},{"doc":"Declares an attribute on the resourceType can be either a built in type (see Ash.Type) for more, or a module implementing the Ash.Type behaviour.Examplesattribute :first_name, :string, primary_key?: trueArguments:name - The name of the attribute.:type - The type of the attribute.Options:constraints - Constraints to provide to the type when casting the value. See the type's documentation for more information.:primary_key? - Whether or not the attribute is part of the primary key (one or more fields that uniquely identify a resource) The default value is false.:allow_nil? - Whether or not the attribute can be set to nil The default value is true.:generated? - Whether or not the value may be generated by the data layer. If it is, the data layer will know to read the value back after writing. The default value is false.:writable? - Whether or not the value can be written to The default value is true.:update_default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on update, this value is used.:default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on create, this value is used.:description - An optional description for the attribute","ref":"Ash.Resource.Dsl.Attribute.html#attribute/3","title":"Ash.Resource.Dsl.Attribute.attribute/3","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.BelongsTo.html","title":"Ash.Resource.Dsl.BelongsTo","type":"module"},{"doc":"Declares a belongs_to relationship. In a relational database, the foreign key would be on the source table.This creates a field on the resource with the corresponding name and type, unless define_field?: false is provided.Examples# In a resource called `Word` belongs_to :dictionary_entry, DictionaryEntry, source_field: :text, destination_field: :word_text Arguments:name - The name of the relationship:destination - The destination resourceOptions:primary_key? - Whether this field is, or is part of, the primary key of a resource. The default value is false.:define_field? - If set to false a field is not created on the resource for this relationship, and one must be manually added in attributes. The default value is true.:field_type - The field type of the automatically created field. The default value is :uuid.:destination_field - The field on the related resource that should match the source_field on this resource. The default value is :id.:source_field - The field on this resource that should match the destination_field on the related resource. - Defaults to &lt;name&gt;_id:writable? - Whether or not the relationship may be edited. The default value is true.","ref":"Ash.Resource.Dsl.BelongsTo.html#belongs_to/3","title":"Ash.Resource.Dsl.BelongsTo.belongs_to/3","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.Count.html","title":"Ash.Resource.Dsl.Count","type":"module"},{"doc":"Declares a named aggregate on the resourceExamplescount :assigned_ticket_count, :reported_tickets, filter: [active: true]Arguments:name - The field to place the aggregate in:relationship_path - The relationship or relationship path to use for the aggregateOptions:kind - Required. The kind of the aggregate:filter - A filter to apply to the aggregate The default value is [].","ref":"Ash.Resource.Dsl.Count.html#count/3","title":"Ash.Resource.Dsl.Count.count/3","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.Create.html","title":"Ash.Resource.Dsl.Create","type":"module"},{"doc":"Declares a create action. For calling this action, see the Ash.Api documentation.Examplescreate :register, primary?: trueArguments:name - The name of the actionOptions:primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false.","ref":"Ash.Resource.Dsl.Create.html#create/2","title":"Ash.Resource.Dsl.Create.create/2","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.CreateTimestamp.html","title":"Ash.Resource.Dsl.CreateTimestamp","type":"module"},{"doc":"Declares a non-writable attribute with a create default of &amp;DateTime.utc_now/0Examplescreate_timestamp :inserted_atArguments:name - The name of the attribute.Options:type - The type of the attribute. The default value is :utc_datetime.:constraints - Constraints to provide to the type when casting the value. See the type's documentation for more information.:primary_key? - Whether or not the attribute is part of the primary key (one or more fields that uniquely identify a resource) The default value is false.:allow_nil? - Whether or not the attribute can be set to nil The default value is true.:generated? - Whether or not the value may be generated by the data layer. If it is, the data layer will know to read the value back after writing. The default value is false.:writable? - Whether or not the value can be written to The default value is false.:update_default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on update, this value is used.:default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on create, this value is used. The default value is &amp;DateTime.utc_now/0.:description - An optional description for the attribute","ref":"Ash.Resource.Dsl.CreateTimestamp.html#create_timestamp/2","title":"Ash.Resource.Dsl.CreateTimestamp.create_timestamp/2","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.Destroy.html","title":"Ash.Resource.Dsl.Destroy","type":"module"},{"doc":"Declares a destroy action. For calling this action, see the Ash.Api documentation.Examplesdestroy :soft_delete, primary?: trueArguments:name - The name of the actionOptions:primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false.","ref":"Ash.Resource.Dsl.Destroy.html#destroy/2","title":"Ash.Resource.Dsl.Destroy.destroy/2","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.HasMany.html","title":"Ash.Resource.Dsl.HasMany","type":"module"},{"doc":"Declares a has_many relationship. There can be any number of related entities.Examples# In a resource called `Word` has_many :definitions, DictionaryDefinition, source_field: :text, destination_field: :word_text Arguments:name - The name of the relationship:destination - The destination resourceOptions:destination_field - Required. The field on the related resource that should match the source_field on this resource.:source_field - The field on this resource that should match the destination_field on the related resource. The default value is :id.:writable? - Whether or not the relationship may be edited. The default value is true.","ref":"Ash.Resource.Dsl.HasMany.html#has_many/3","title":"Ash.Resource.Dsl.HasMany.has_many/3","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.HasOne.html","title":"Ash.Resource.Dsl.HasOne","type":"module"},{"doc":"Declares a has_one relationship. In a relationsal database, the foreign key would be on the other table.Generally speaking, a has_one also implies that the destination table is unique on that foreign key.Examples# In a resource called `Word` has_one :dictionary_entry, DictionaryEntry, source_field: :text, destination_field: :word_text Arguments:name - The name of the relationship:destination - The destination resourceOptions:destination_field - Required. The field on the related resource that should match the source_field on this resource.:source_field - The field on this resource that should match the destination_field on the related resource. The default value is :id.:writable? - Whether or not the relationship may be edited. The default value is true.","ref":"Ash.Resource.Dsl.HasOne.html#has_one/3","title":"Ash.Resource.Dsl.HasOne.has_one/3","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.ManyToMany.html","title":"Ash.Resource.Dsl.ManyToMany","type":"module"},{"doc":"Declares a many_to_many relationship. Many to many relationships require a join table.A join table is typically a table who's primary key consists of one foreign key to each resource.Examples# In a resource called `Word` many_to_many :books, Book, through: BookWord, source_field: :text, source_field_on_join_table: :word_text, destination_field: :id, destination_field_on_join_table: :book_id Arguments:name - The name of the relationship:destination - The destination resourceOptions:source_field_on_join_table - Required. The field on the join table that should line up with source_field on this resource.:destination_field_on_join_table - Required. The field on the join table that should line up with destination_field on the related resource. Default: [relationshihp_name]_id:through - Required. The resource to use as the join resource.:join_relationship - The has_many relationship to the join table. Defaults to &lt;relationship_name&gt;_join_assoc:join_attributes - Attributes to expose as editable when modifying the relationship.Extensions may use this when deciding what fields to render from the join table.See Ash.Changeset.append_to_relationship/3 and Ash.Changeset.replace_relationship/3 for how to edit these fields. The default value is [].:destination_field - The field on the related resource that should match the source_field on this resource. The default value is :id.:source_field - The field on this resource that should match the destination_field on the related resource. The default value is :id.:writable? - Whether or not the relationship may be edited. The default value is true.","ref":"Ash.Resource.Dsl.ManyToMany.html#many_to_many/3","title":"Ash.Resource.Dsl.ManyToMany.many_to_many/3","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.Read.html","title":"Ash.Resource.Dsl.Read","type":"module"},{"doc":"Declares a read action. For calling this action, see the Ash.Api documentation.Examplesread :read_all, primary?: trueArguments:name - The name of the actionOptions:primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false.","ref":"Ash.Resource.Dsl.Read.html#read/2","title":"Ash.Resource.Dsl.Read.read/2","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.Update.html","title":"Ash.Resource.Dsl.Update","type":"module"},{"doc":"Declares a update action. For calling this action, see the Ash.Api documentation.Examplesupdate :flag_for_review, primary?: trueArguments:name - The name of the actionOptions:primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false.","ref":"Ash.Resource.Dsl.Update.html#update/2","title":"Ash.Resource.Dsl.Update.update/2","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.UpdateTimestamp.html","title":"Ash.Resource.Dsl.UpdateTimestamp","type":"module"},{"doc":"Declares a non-writable attribute with a create and update default of &amp;DateTime.utc_now/0Examplesupdate_timestamp :inserted_atArguments:name - The name of the attribute.Options:type - The type of the attribute. The default value is :utc_datetime.:constraints - Constraints to provide to the type when casting the value. See the type's documentation for more information.:primary_key? - Whether or not the attribute is part of the primary key (one or more fields that uniquely identify a resource) The default value is false.:allow_nil? - Whether or not the attribute can be set to nil The default value is true.:generated? - Whether or not the value may be generated by the data layer. If it is, the data layer will know to read the value back after writing. The default value is false.:writable? - Whether or not the value can be written to The default value is false.:update_default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on update, this value is used. The default value is &amp;DateTime.utc_now/0.:default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on create, this value is used. The default value is &amp;DateTime.utc_now/0.:description - An optional description for the attribute","ref":"Ash.Resource.Dsl.UpdateTimestamp.html#update_timestamp/2","title":"Ash.Resource.Dsl.UpdateTimestamp.update_timestamp/2","type":"macro"},{"doc":"","ref":"Ash.Resource.Dsl.Validate.html","title":"Ash.Resource.Dsl.Validate","type":"module"},{"doc":"Declares a validation for creates and updates.Examplesvalidate {Mod, [foo: :bar]}validate at_least_one_of_present([:first_name, :last_name])Arguments:validation - The module/opts pair of the validationOptions:on - The action types the validation should run on.Many validations don't make sense in the context of deletion, so by default it is left out of the list. The default value is [:create, :update].:expensive? - If a validation is expensive, it won't be run on invalid changes. All inexpensive validations are always run, to provide informative validations. The default value is false.","ref":"Ash.Resource.Dsl.Validate.html#validate/2","title":"Ash.Resource.Dsl.Validate.validate/2","type":"macro"},{"doc":"Creates the attribute for belongs_to relationships that have define_field?: true","ref":"Ash.Resource.Transformers.BelongsToAttribute.html","title":"Ash.Resource.Transformers.BelongsToAttribute","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#after?/1","title":"Ash.Resource.Transformers.BelongsToAttribute.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#before?/1","title":"Ash.Resource.Transformers.BelongsToAttribute.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#transform/2","title":"Ash.Resource.Transformers.BelongsToAttribute.transform/2","type":"function"},{"doc":"Sets the default source_field for belongs_to attributes","ref":"Ash.Resource.Transformers.BelongsToSourceField.html","title":"Ash.Resource.Transformers.BelongsToSourceField","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#after?/1","title":"Ash.Resource.Transformers.BelongsToSourceField.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#before?/1","title":"Ash.Resource.Transformers.BelongsToSourceField.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#transform/2","title":"Ash.Resource.Transformers.BelongsToSourceField.transform/2","type":"function"},{"doc":"Validates the primary key of a resource","ref":"Ash.Resource.Transformers.CachePrimaryKey.html","title":"Ash.Resource.Transformers.CachePrimaryKey","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#after?/1","title":"Ash.Resource.Transformers.CachePrimaryKey.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#before?/1","title":"Ash.Resource.Transformers.CachePrimaryKey.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#transform/2","title":"Ash.Resource.Transformers.CachePrimaryKey.transform/2","type":"function"},{"doc":"Creates an automatically named has_many relationship for each many_to_many.This will likely not be around for long, as our logic around many to many relationships will update soon.","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html","title":"Ash.Resource.Transformers.CreateJoinRelationship","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#after?/1","title":"Ash.Resource.Transformers.CreateJoinRelationship.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#before?/1","title":"Ash.Resource.Transformers.CreateJoinRelationship.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#transform/2","title":"Ash.Resource.Transformers.CreateJoinRelationship.transform/2","type":"function"},{"doc":"Creates/validates the primary action configurationIf only one action of a given type is defined, it is marked as primary. If multiple exist, and one is not primary, this results in an error.","ref":"Ash.Resource.Transformers.SetPrimaryActions.html","title":"Ash.Resource.Transformers.SetPrimaryActions","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.SetPrimaryActions.html#after?/1","title":"Ash.Resource.Transformers.SetPrimaryActions.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.SetPrimaryActions.html#before?/1","title":"Ash.Resource.Transformers.SetPrimaryActions.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.SetPrimaryActions.html#transform/2","title":"Ash.Resource.Transformers.SetPrimaryActions.transform/2","type":"function"},{"doc":"Sets the source key on relationships to be the resource they were defined on","ref":"Ash.Resource.Transformers.SetRelationshipSource.html","title":"Ash.Resource.Transformers.SetRelationshipSource","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#after?/1","title":"Ash.Resource.Transformers.SetRelationshipSource.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#before?/1","title":"Ash.Resource.Transformers.SetRelationshipSource.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#transform/2","title":"Ash.Resource.Transformers.SetRelationshipSource.transform/2","type":"function"},{"doc":"Ensures that all resources for a given api are compiled.This is required for later transformers.","ref":"Ash.Api.Transformers.EnsureResourcesCompiled.html","title":"Ash.Api.Transformers.EnsureResourcesCompiled","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Api.Transformers.EnsureResourcesCompiled.html#after?/1","title":"Ash.Api.Transformers.EnsureResourcesCompiled.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Api.Transformers.EnsureResourcesCompiled.html#before?/1","title":"Ash.Api.Transformers.EnsureResourcesCompiled.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Api.Transformers.EnsureResourcesCompiled.html#transform/2","title":"Ash.Api.Transformers.EnsureResourcesCompiled.transform/2","type":"function"},{"doc":"Validates that join_attributes on many to many relationships exist on the join resource","ref":"Ash.Api.Transformers.ValidateManyToManyJoinAttributes.html","title":"Ash.Api.Transformers.ValidateManyToManyJoinAttributes","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Api.Transformers.ValidateManyToManyJoinAttributes.html#after?/1","title":"Ash.Api.Transformers.ValidateManyToManyJoinAttributes.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Api.Transformers.ValidateManyToManyJoinAttributes.html#before?/1","title":"Ash.Api.Transformers.ValidateManyToManyJoinAttributes.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Api.Transformers.ValidateManyToManyJoinAttributes.html#transform/2","title":"Ash.Api.Transformers.ValidateManyToManyJoinAttributes.transform/2","type":"function"},{"doc":"Ensures that all related resources are included in an API.","ref":"Ash.Api.Transformers.ValidateRelatedResourceInclusion.html","title":"Ash.Api.Transformers.ValidateRelatedResourceInclusion","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Api.Transformers.ValidateRelatedResourceInclusion.html#before?/1","title":"Ash.Api.Transformers.ValidateRelatedResourceInclusion.before?/1","type":"function"},{"doc":"Validates that all relationships point to valid fields","ref":"Ash.Api.Transformers.ValidateRelationshipAttributes.html","title":"Ash.Api.Transformers.ValidateRelationshipAttributes","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Api.Transformers.ValidateRelationshipAttributes.html#after?/1","title":"Ash.Api.Transformers.ValidateRelationshipAttributes.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Api.Transformers.ValidateRelationshipAttributes.html#before?/1","title":"Ash.Api.Transformers.ValidateRelationshipAttributes.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Api.Transformers.ValidateRelationshipAttributes.html#transform/2","title":"Ash.Api.Transformers.ValidateRelationshipAttributes.transform/2","type":"function"},{"doc":"A small DSL for declaring APIsApis are the entrypoints for working with your resources.resources - resources/1","ref":"Ash.Api.Dsl.html","title":"Ash.Api.Dsl","type":"module"},{"doc":"List the resources present in this APIConstructorsresource - Ash.Api.Dsl.Resource","ref":"Ash.Api.Dsl.html#resources/1","title":"Ash.Api.Dsl.resources/1","type":"macro"},{"doc":"","ref":"Ash.Api.Dsl.Resource.html","title":"Ash.Api.Dsl.Resource","type":"module"},{"doc":"A reference to a resourceExamplesresource MyApp.UserArguments:resource - The module of the resource","ref":"Ash.Api.Dsl.Resource.html#resource/2","title":"Ash.Api.Dsl.Resource.resource/2","type":"macro"},{"doc":"Represents a filter predicate","ref":"Ash.Filter.Predicate.html","title":"Ash.Filter.Predicate","type":"behaviour"},{"doc":"","ref":"Ash.Filter.Predicate.html#add_inspect_path/2","title":"Ash.Filter.Predicate.add_inspect_path/2","type":"function"},{"doc":"","ref":"Ash.Filter.Predicate.html#compare/2","title":"Ash.Filter.Predicate.compare/2","type":"function"},{"doc":"","ref":"Ash.Filter.Predicate.html#c:compare/2","title":"Ash.Filter.Predicate.compare/2","type":"callback"},{"doc":"","ref":"Ash.Filter.Predicate.html#match?/3","title":"Ash.Filter.Predicate.match?/3","type":"function"},{"doc":"","ref":"Ash.Filter.Predicate.html#c:match?/3","title":"Ash.Filter.Predicate.match?/3","type":"callback"},{"doc":"","ref":"Ash.Filter.Predicate.html#c:new/3","title":"Ash.Filter.Predicate.new/3","type":"callback"},{"doc":"","ref":"Ash.Filter.Predicate.html#new/5","title":"Ash.Filter.Predicate.new/5","type":"function"},{"doc":"","ref":"Ash.Filter.Predicate.html#t:comparison/0","title":"Ash.Filter.Predicate.comparison/0","type":"type"},{"doc":"","ref":"Ash.Filter.Predicate.html#t:predicate/0","title":"Ash.Filter.Predicate.predicate/0","type":"type"},{"doc":"","ref":"Ash.Filter.Predicate.html#t:t/0","title":"Ash.Filter.Predicate.t/0","type":"type"},{"doc":"A predicate for strict value equality","ref":"Ash.Filter.Predicate.Eq.html","title":"Ash.Filter.Predicate.Eq","type":"module"},{"doc":"Callback implementation for Ash.Filter.Predicate.new/3.","ref":"Ash.Filter.Predicate.Eq.html#new/3","title":"Ash.Filter.Predicate.Eq.new/3","type":"function"},{"doc":"A predicate for a value being greater than the provided value","ref":"Ash.Filter.Predicate.GreaterThan.html","title":"Ash.Filter.Predicate.GreaterThan","type":"module"},{"doc":"Callback implementation for Ash.Filter.Predicate.new/3.","ref":"Ash.Filter.Predicate.GreaterThan.html#new/3","title":"Ash.Filter.Predicate.GreaterThan.new/3","type":"function"},{"doc":"A predicate for a value being in a list of provided values","ref":"Ash.Filter.Predicate.In.html","title":"Ash.Filter.Predicate.In","type":"module"},{"doc":"Callback implementation for Ash.Filter.Predicate.new/3.","ref":"Ash.Filter.Predicate.In.html#new/3","title":"Ash.Filter.Predicate.In.new/3","type":"function"},{"doc":"A predicate for a value being greater than the provided value","ref":"Ash.Filter.Predicate.LessThan.html","title":"Ash.Filter.Predicate.LessThan","type":"module"},{"doc":"Callback implementation for Ash.Filter.Predicate.new/3.","ref":"Ash.Filter.Predicate.LessThan.html#new/3","title":"Ash.Filter.Predicate.LessThan.new/3","type":"function"},{"doc":"The representation of a filter in Ash.Ash filters are stored as nested Ash.Filter.Expression{} and %Ash.Filter.Not{} structs, terminating in a %Ash.Filter.Predicate{} struct. An expression is simply a boolean operator and the left and right hand side of that operator.","ref":"Ash.Filter.html","title":"Ash.Filter","type":"module"},{"doc":"","ref":"Ash.Filter.html#add_to_filter/4","title":"Ash.Filter.add_to_filter/4","type":"function"},{"doc":"","ref":"Ash.Filter.html#add_to_filter!/4","title":"Ash.Filter.add_to_filter!/4","type":"function"},{"doc":"","ref":"Ash.Filter.html#do_map/2","title":"Ash.Filter.do_map/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#do_reduce/3","title":"Ash.Filter.do_reduce/3","type":"function"},{"doc":"","ref":"Ash.Filter.html#filter_expression_by_relationship_path/3","title":"Ash.Filter.filter_expression_by_relationship_path/3","type":"function"},{"doc":"","ref":"Ash.Filter.html#map/2","title":"Ash.Filter.map/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#parse/3","title":"Ash.Filter.parse/3","type":"function"},{"doc":"","ref":"Ash.Filter.html#parse!/3","title":"Ash.Filter.parse!/3","type":"function"},{"doc":"","ref":"Ash.Filter.html#put_at_path/2","title":"Ash.Filter.put_at_path/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#read_requests/2","title":"Ash.Filter.read_requests/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#reduce/3","title":"Ash.Filter.reduce/3","type":"function"},{"doc":"","ref":"Ash.Filter.html#relationship_filter_request_paths/1","title":"Ash.Filter.relationship_filter_request_paths/1","type":"function"},{"doc":"","ref":"Ash.Filter.html#relationship_paths/2","title":"Ash.Filter.relationship_paths/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#remove_aggregates/1","title":"Ash.Filter.remove_aggregates/1","type":"function"},{"doc":"","ref":"Ash.Filter.html#run_other_data_layer_filters/3","title":"Ash.Filter.run_other_data_layer_filters/3","type":"function"},{"doc":"Returns true if the second argument is a strict subset (always returns the same or less data) of the first","ref":"Ash.Filter.html#strict_subset_of/2","title":"Ash.Filter.strict_subset_of/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#strict_subset_of?/2","title":"Ash.Filter.strict_subset_of?/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#used_aggregates/1","title":"Ash.Filter.used_aggregates/1","type":"function"},{"doc":"","ref":"Ash.Filter.html#t:t/0","title":"Ash.Filter.t/0","type":"type"},{"doc":"Represents a boolean expression","ref":"Ash.Filter.Expression.html","title":"Ash.Filter.Expression","type":"module"},{"doc":"","ref":"Ash.Filter.Expression.html#new/3","title":"Ash.Filter.Expression.new/3","type":"function"},{"doc":"Represents the negation of the contained expression","ref":"Ash.Filter.Not.html","title":"Ash.Filter.Not","type":"module"},{"doc":"","ref":"Ash.Filter.Not.html#new/1","title":"Ash.Filter.Not.new/1","type":"function"},{"doc":"Checks a record to see if it matches a filter statement.We can't always tell if a record matches a filter statement, and as such this function may return :unknown","ref":"Ash.Filter.Runtime.html","title":"Ash.Filter.Runtime","type":"module"},{"doc":"","ref":"Ash.Filter.Runtime.html#matches?/4","title":"Ash.Filter.Runtime.matches?/4","type":"function"},{"doc":"A resource is a static definition of an entity in your system.Resource DSL documentation: Ash.Resource.Dsl","ref":"Ash.Resource.html","title":"Ash.Resource","type":"module"},{"doc":"Returns the action with the matching name and type on the resource","ref":"Ash.Resource.html#action/3","title":"Ash.Resource.action/3","type":"function"},{"doc":"Returns all actions of a resource","ref":"Ash.Resource.html#actions/1","title":"Ash.Resource.actions/1","type":"function"},{"doc":"","ref":"Ash.Resource.html#aggregate/2","title":"Ash.Resource.aggregate/2","type":"function"},{"doc":"","ref":"Ash.Resource.html#aggregates/1","title":"Ash.Resource.aggregates/1","type":"function"},{"doc":"Get an attribute name from the resource","ref":"Ash.Resource.html#attribute/2","title":"Ash.Resource.attribute/2","type":"function"},{"doc":"Returns all attributes of a resource","ref":"Ash.Resource.html#attributes/1","title":"Ash.Resource.attributes/1","type":"function"},{"doc":"A list of authorizers to be used when accessing","ref":"Ash.Resource.html#authorizers/1","title":"Ash.Resource.authorizers/1","type":"function"},{"doc":"The data layer of the resource, or nil if it does not have one","ref":"Ash.Resource.html#data_layer/1","title":"Ash.Resource.data_layer/1","type":"function"},{"doc":"Whether ornot the data layer supports a specific feature","ref":"Ash.Resource.html#data_layer_can?/2","title":"Ash.Resource.data_layer_can?/2","type":"function"},{"doc":"Custom filters suppoted by the data layer of the resource","ref":"Ash.Resource.html#data_layer_filters/1","title":"Ash.Resource.data_layer_filters/1","type":"function"},{"doc":"","ref":"Ash.Resource.html#description/1","title":"Ash.Resource.description/1","type":"function"},{"doc":"","ref":"Ash.Resource.html#extensions/1","title":"Ash.Resource.extensions/1","type":"function"},{"doc":"Whether or not the data layer for the resource is currently in a transaction","ref":"Ash.Resource.html#in_transaction?/1","title":"Ash.Resource.in_transaction?/1","type":"function"},{"doc":"Returns the primary action of a given type","ref":"Ash.Resource.html#primary_action/2","title":"Ash.Resource.primary_action/2","type":"function"},{"doc":"Returns the primary action of the given type","ref":"Ash.Resource.html#primary_action!/2","title":"Ash.Resource.primary_action!/2","type":"function"},{"doc":"A list of field names corresponding to the primary key","ref":"Ash.Resource.html#primary_key/1","title":"Ash.Resource.primary_key/1","type":"function"},{"doc":"","ref":"Ash.Resource.html#related/2","title":"Ash.Resource.related/2","type":"function"},{"doc":"Get a relationship by name or path","ref":"Ash.Resource.html#relationship/2","title":"Ash.Resource.relationship/2","type":"function"},{"doc":"","ref":"Ash.Resource.html#relationships/1","title":"Ash.Resource.relationships/1","type":"function"},{"doc":"Whether or not a given module is a resource module","ref":"Ash.Resource.html#resource?/1","title":"Ash.Resource.resource?/1","type":"function"},{"doc":"Rolls back the current transaction","ref":"Ash.Resource.html#rollback/2","title":"Ash.Resource.rollback/2","type":"function"},{"doc":"Wraps the execution of the function in a transaction with the resource's datalayer","ref":"Ash.Resource.html#transaction/2","title":"Ash.Resource.transaction/2","type":"function"},{"doc":"A list of all validations for the resource","ref":"Ash.Resource.html#validations/1","title":"Ash.Resource.validations/1","type":"function"},{"doc":"","ref":"Ash.Resource.html#validations/2","title":"Ash.Resource.validations/2","type":"function"},{"doc":"Represents a create action on a resource.","ref":"Ash.Resource.Actions.Create.html","title":"Ash.Resource.Actions.Create","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Create.html#t:t/0","title":"Ash.Resource.Actions.Create.t/0","type":"type"},{"doc":"Represents a destroy action on a resource.","ref":"Ash.Resource.Actions.Destroy.html","title":"Ash.Resource.Actions.Destroy","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Destroy.html#t:t/0","title":"Ash.Resource.Actions.Destroy.t/0","type":"type"},{"doc":"Represents a read action on a resource.","ref":"Ash.Resource.Actions.Read.html","title":"Ash.Resource.Actions.Read","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Read.html#t:t/0","title":"Ash.Resource.Actions.Read.t/0","type":"type"},{"doc":"Represents a update action on a resource.","ref":"Ash.Resource.Actions.Update.html","title":"Ash.Resource.Actions.Update","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Update.html#t:t/0","title":"Ash.Resource.Actions.Update.t/0","type":"type"},{"doc":"Represents a named aggregate on the resource that can be loaded","ref":"Ash.Resource.Aggregate.html","title":"Ash.Resource.Aggregate","type":"module"},{"doc":"","ref":"Ash.Resource.Aggregate.html#relationship_path/1","title":"Ash.Resource.Aggregate.relationship_path/1","type":"function"},{"doc":"Represents an attribute on a resource","ref":"Ash.Resource.Attribute.html","title":"Ash.Resource.Attribute","type":"module"},{"doc":"","ref":"Ash.Resource.Attribute.html#create_timestamp_schema/0","title":"Ash.Resource.Attribute.create_timestamp_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Attribute.html#transform/1","title":"Ash.Resource.Attribute.transform/1","type":"function"},{"doc":"","ref":"Ash.Resource.Attribute.html#update_timestamp_schema/0","title":"Ash.Resource.Attribute.update_timestamp_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Attribute.html#validate_default/2","title":"Ash.Resource.Attribute.validate_default/2","type":"function"},{"doc":"","ref":"Ash.Resource.Attribute.html#t:t/0","title":"Ash.Resource.Attribute.t/0","type":"type"},{"doc":"Represents a belongs_to relationship on a resource","ref":"Ash.Resource.Relationships.BelongsTo.html","title":"Ash.Resource.Relationships.BelongsTo","type":"module"},{"doc":"","ref":"Ash.Resource.Relationships.BelongsTo.html#t:t/0","title":"Ash.Resource.Relationships.BelongsTo.t/0","type":"type"},{"doc":"Represents a has_many relationship on a resource","ref":"Ash.Resource.Relationships.HasMany.html","title":"Ash.Resource.Relationships.HasMany","type":"module"},{"doc":"","ref":"Ash.Resource.Relationships.HasMany.html#t:t/0","title":"Ash.Resource.Relationships.HasMany.t/0","type":"type"},{"doc":"Represents a has_one relationship on a resource","ref":"Ash.Resource.Relationships.HasOne.html","title":"Ash.Resource.Relationships.HasOne","type":"module"},{"doc":"","ref":"Ash.Resource.Relationships.HasOne.html#t:t/0","title":"Ash.Resource.Relationships.HasOne.t/0","type":"type"},{"doc":"Represents a many_to_many relationship on a resource","ref":"Ash.Resource.Relationships.ManyToMany.html","title":"Ash.Resource.Relationships.ManyToMany","type":"module"},{"doc":"","ref":"Ash.Resource.Relationships.ManyToMany.html#transform/1","title":"Ash.Resource.Relationships.ManyToMany.transform/1","type":"function"},{"doc":"","ref":"Ash.Resource.Relationships.ManyToMany.html#t:t/0","title":"Ash.Resource.Relationships.ManyToMany.t/0","type":"type"},{"doc":"Represents a validation in Ash.See Ash.Resource.Validation.Builtin for a list of builtin validations.To write your own validation, define a module that implements the init/1 callback to validate options at compile time, and validate/2 callback to do the validation.Then, in a resource, you can say:validations do validation {MyValidation, [foo: :bar]} endTo make it more readable, you can define a function in the module that returns that tuple, and import it into your resource.defmodule MyValidation do def my_validation(value) do {__MODULE__, foo: value} end enddefmodule MyResource do ... import MyValidation validations do validate my_validation(:foo) end end","ref":"Ash.Resource.Validation.html","title":"Ash.Resource.Validation","type":"behaviour"},{"doc":"","ref":"Ash.Resource.Validation.html#c:init/1","title":"Ash.Resource.Validation.init/1","type":"callback"},{"doc":"","ref":"Ash.Resource.Validation.html#on/1","title":"Ash.Resource.Validation.on/1","type":"function"},{"doc":"","ref":"Ash.Resource.Validation.html#opt_schema/0","title":"Ash.Resource.Validation.opt_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Validation.html#transform/1","title":"Ash.Resource.Validation.transform/1","type":"function"},{"doc":"","ref":"Ash.Resource.Validation.html#c:validate/2","title":"Ash.Resource.Validation.validate/2","type":"callback"},{"doc":"","ref":"Ash.Resource.Validation.html#validation/1","title":"Ash.Resource.Validation.validation/1","type":"function"},{"doc":"","ref":"Ash.Resource.Validation.html#t:path/0","title":"Ash.Resource.Validation.path/0","type":"type"},{"doc":"","ref":"Ash.Resource.Validation.html#t:t/0","title":"Ash.Resource.Validation.t/0","type":"type"},{"doc":"Built in validations that are available to all resourcesThe functions in this module are imported by default in the validations section.","ref":"Ash.Resource.Validation.Builtins.html","title":"Ash.Resource.Validation.Builtins","type":"module"},{"doc":"","ref":"Ash.Resource.Validation.Builtins.html#absent/2","title":"Ash.Resource.Validation.Builtins.absent/2","type":"function"},{"doc":"","ref":"Ash.Resource.Validation.Builtins.html#present/2","title":"Ash.Resource.Validation.Builtins.present/2","type":"function"},{"doc":"Validates that the provided attribute is non-nil","ref":"Ash.Resource.Validation.Present.html","title":"Ash.Resource.Validation.Present","type":"module"},{"doc":"Represents a resource in an API","ref":"Ash.Api.ResourceReference.html","title":"Ash.Api.ResourceReference","type":"module"},{"doc":"Used when an aggregate or relationship hasn't been loaded.","ref":"Ash.NotLoaded.html","title":"Ash.NotLoaded","type":"module"},{"doc":"Represents an aggregated association value","ref":"Ash.Query.Aggregate.html","title":"Ash.Query.Aggregate","type":"module"},{"doc":"","ref":"Ash.Query.Aggregate.html#new/5","title":"Ash.Query.Aggregate.new/5","type":"function"},{"doc":"","ref":"Ash.Query.Aggregate.html#requests/3","title":"Ash.Query.Aggregate.requests/3","type":"function"},{"doc":"","ref":"Ash.Query.Aggregate.html#t:kind/0","title":"Ash.Query.Aggregate.kind/0","type":"type"},{"doc":"","ref":"Ash.Query.Aggregate.html#t:t/0","title":"Ash.Query.Aggregate.t/0","type":"type"},{"doc":"Used when an invalid value is provided for an attribute change","ref":"Ash.Error.Changes.InvalidAttribute.html","title":"Ash.Error.Changes.InvalidAttribute","type":"exception"},{"doc":"Used when a change is provided that covers multiple attributes/relationships","ref":"Ash.Error.Changes.InvalidChanges.html","title":"Ash.Error.Changes.InvalidChanges","type":"exception"},{"doc":"Used when an invalid value is provided for a relationship change","ref":"Ash.Error.Changes.InvalidRelationship.html","title":"Ash.Error.Changes.InvalidRelationship","type":"exception"},{"doc":"Used when a change is provided for an attribute that does not exist","ref":"Ash.Error.Changes.NoSuchAttribute.html","title":"Ash.Error.Changes.NoSuchAttribute","type":"exception"},{"doc":"Used when a change is provided for an relationship that does not exist","ref":"Ash.Error.Changes.NoSuchRelationship.html","title":"Ash.Error.Changes.NoSuchRelationship","type":"exception"},{"doc":"Used when a change fails for an unknown reason","ref":"Ash.Error.Changes.UnknownError.html","title":"Ash.Error.Changes.UnknownError","type":"exception"},{"doc":"Used when a DSL is incorrectly configured.","ref":"Ash.Error.Dsl.DslError.html","title":"Ash.Error.Dsl.DslError","type":"exception"},{"doc":"Used when authorization for an action fails","ref":"Ash.Error.Forbidden.html","title":"Ash.Error.Forbidden","type":"exception"},{"doc":"Used when unreachable code/conditions are reached in the framework","ref":"Ash.Error.Forbidden.MustPassStrictCheck.html","title":"Ash.Error.Forbidden.MustPassStrictCheck","type":"exception"},{"doc":"Used when an unknown/generic framework error occurs","ref":"Ash.Error.Framework.html","title":"Ash.Error.Framework","type":"exception"},{"doc":"Used when unreachable code/conditions are reached in the framework","ref":"Ash.Error.Framework.AssumptionFailed.html","title":"Ash.Error.Framework.AssumptionFailed","type":"exception"},{"doc":"Used when the sycnrhonous engine cannot proceed","ref":"Ash.Error.Framework.SynchronousEngineStuck.html","title":"Ash.Error.Framework.SynchronousEngineStuck","type":"exception"},{"doc":"The top level invalid error","ref":"Ash.Error.Invalid.html","title":"Ash.Error.Invalid","type":"exception"},{"doc":"Used when multiple requests with the same path are passed to the internal engine","ref":"Ash.Error.Invalid.DuplicatedPath.html","title":"Ash.Error.Invalid.DuplicatedPath","type":"exception"},{"doc":"Used when a request expresses a dependency on another request that doesn't exist","ref":"Ash.Error.Invalid.ImpossiblePath.html","title":"Ash.Error.Invalid.ImpossiblePath","type":"exception"},{"doc":"Used when an invalid primary key is given to an Api's get","ref":"Ash.Error.Invalid.InvalidPrimaryKey.html","title":"Ash.Error.Invalid.InvalidPrimaryKey","type":"exception"},{"doc":"Used when an action name is provided that doesn't exist","ref":"Ash.Error.Invalid.NoSuchAction.html","title":"Ash.Error.Invalid.NoSuchAction","type":"exception"},{"doc":"Used when a resource or alias is provided that doesn't exist","ref":"Ash.Error.Invalid.NoSuchResource.html","title":"Ash.Error.Invalid.NoSuchResource","type":"exception"},{"doc":"Used when the datalayer does not support aggregates, or filtering/sorting them","ref":"Ash.Error.Query.AggregatesNotSupported.html","title":"Ash.Error.Query.AggregatesNotSupported","type":"exception"},{"doc":"Used when an invalid value is provided for a filter","ref":"Ash.Error.Query.InvalidFilterValue.html","title":"Ash.Error.Query.InvalidFilterValue","type":"exception"},{"doc":"Used when an invalid limit is provided","ref":"Ash.Error.Query.InvalidLimit.html","title":"Ash.Error.Query.InvalidLimit","type":"exception"},{"doc":"Used when an invalid load is provided","ref":"Ash.Error.Query.InvalidLoad.html","title":"Ash.Error.Query.InvalidLoad","type":"exception"},{"doc":"Used when an invalid offset is provided","ref":"Ash.Error.Query.InvalidOffset.html","title":"Ash.Error.Query.InvalidOffset","type":"exception"},{"doc":"Used when an invalid sort order is provided","ref":"Ash.Error.Query.InvalidSortOrder.html","title":"Ash.Error.Query.InvalidSortOrder","type":"exception"},{"doc":"Used when an attribute that doesn't exist is used in a query","ref":"Ash.Error.Query.NoSuchAttribute.html","title":"Ash.Error.Query.NoSuchAttribute","type":"exception"},{"doc":"Used when a key in a filter contains something that is neither an attribute or a relationship","ref":"Ash.Error.Query.NoSuchAttributeOrRelationship.html","title":"Ash.Error.Query.NoSuchAttributeOrRelationship","type":"exception"},{"doc":"Used when a filter predicate that does not exist is referenced","ref":"Ash.Error.Query.NoSuchFilterPredicate.html","title":"Ash.Error.Query.NoSuchFilterPredicate","type":"exception"},{"doc":"Used when a relationship is filtered and the destination does not have a default read action","ref":"Ash.Error.Query.ReadActionRequired.html","title":"Ash.Error.Query.ReadActionRequired","type":"exception"},{"doc":"Used when attempting to sort on a field that cannot be used for sorting","ref":"Ash.Error.Query.UnsortableAttribute.html","title":"Ash.Error.Query.UnsortableAttribute","type":"exception"},{"doc":"Used when the datalayer does not support a provided predicate","ref":"Ash.Error.Query.UnsupportedPredicate.html","title":"Ash.Error.Query.UnsupportedPredicate","type":"exception"},{"doc":"Used when an invalid query is provided in a side load","ref":"Ash.Error.SideLoad.InvalidQuery.html","title":"Ash.Error.SideLoad.InvalidQuery","type":"exception"},{"doc":"Used when attempting to side load a relationship that does not exist","ref":"Ash.Error.SideLoad.NoSuchRelationship.html","title":"Ash.Error.SideLoad.NoSuchRelationship","type":"exception"},{"doc":"The top level unknown error container","ref":"Ash.Error.Unknown.html","title":"Ash.Error.Unknown","type":"exception"},{"doc":"Getting Started","ref":"getting_started.html","title":"Getting Started","type":"extras"},{"doc":"For information on creating a new Elixir application, see this guide","ref":"getting_started.html#creating-an-application","title":"Getting Started - Creating an application","type":"extras"},{"doc":"Add ash to your dependencies in mix.exs. The latest version can be found by running mix hex.info ash.","ref":"getting_started.html#add-ash","title":"Getting Started - Add Ash","type":"extras"},{"doc":"Create an API module. This will be your primary way to interact with your Ash resources. We recommend lib/api.ex for simple setups.defmodule MyApp.Api do use Ash.Api resources do end end","ref":"getting_started.html#create-an-ash-api","title":"Getting Started - Create an Ash API","type":"extras"},{"doc":"A resource is the primary entity in Ash. Your Api module ties your resources together and gives them an interface, but the vast majority if your configuration will live in a resource. In your typical setup, you might have a resource per database table. For those already familiar with ecto, a resource and an ecto schema are very similar. In fact, all resources define an ecto schema under the hood. This can be leveraged when you need to do things that are not yet implemented or fall outside of the scope of Ash. The current recommendation for where to put your resources is in lib/resources/&lt;resource_name&gt;.ex. Here are a few examples:# in lib/resources/tweet.ex defmodule MyApp.Tweet do use Ash.Resource attributes do attribute :id, :uuid do # All ash resources currently require a primary key # Eventually, we will add good defaults and/or allow # for a global configuration of your default primary key primary_key? true allow_nil? false writable? false default &amp;Ecto.UUID.generate/0 end attribute :body, :string do allow_nil? false constraints [max_length: 255] end # Alternatively, you can use the keyword list syntax # `{:constant, &lt;value&gt;}` is how you set a default # You can also set functional defaults, via passing in a zero # argument function or an MFA attribute :public, :boolean, allow_nil?: false, default: {:constant, false} create_timestamp :created_at #This is set on create update_timestamp :updated_at #This is updated on all updates # `create_timestamp` above is just shorthand for: attribute :created_at, :utc_datetime, writable?: false, default: &amp;DateTime.utc_now/0 end relationships do belongs_to :user, MyApp.User end end # in lib/resources/user.ex defmodule MyApp.User do use Ash.Resource attributes do attribute :email, :string, allow_nil?: false, constraints: [ match: ~r/[A-Z0-9._%+-]+@[A-Z0-9.-]+\\.[A-Z]{2,}/ ] end relationships do has_many :tweets, MyApp.Tweet, destination_field: :user_id end end","ref":"getting_started.html#create-a-resource","title":"Getting Started - Create a resource","type":"extras"},{"doc":"Alter your API like so:resources do resource MyApp.User resource MyApp.Tweet end","ref":"getting_started.html#add-resources-to-your-api","title":"Getting Started - Add resources to your API","type":"extras"},{"doc":"Choose a datalayer, and see its documentation for configuring it:Ash.DataLayer.Ets - an ets datalayer only recommended for testingAsh.DataLayer.Mnesia - an mnesia datalayer, not optimized, but is backed by a file and works with distributed applicationsAshPostgres.DataLayer - a Postgres datalayer, currently the primary supported data layerTo add a datalayer, add it to the use Ash.Resource statement:use Ash.Resource, data_layer: AshPostgres.DataLayer","ref":"getting_started.html#add-your-datalayer","title":"Getting Started - Add your datalayer","type":"extras"},{"doc":"Currently, actions do not offer any customization, but eventually they will be the primary driver for adding specific interactions to your resource. For now, to enable all of them, add the following to your resource:actions do create :default read :default update :default destroy :default end","ref":"getting_started.html#add-actions-to-enable-functionality","title":"Getting Started - Add actions to enable functionality","type":"extras"},{"doc":"AshJsonApi - can be used to build a spec compliant JSON:API","ref":"getting_started.html#add-front-end-extensions","title":"Getting Started - Add front end extensions","type":"extras"},{"doc":"Ash.Api for what you can do with your resources.Ash.Query for the kinds of queries you can make.Ash.Resource.Dsl for the resource DSL documentation.Ash.Api.Dsl for the API DSL documentation.","ref":"getting_started.html#see-ash-documentation-for-the-rest","title":"Getting Started - See Ash documentation for the rest","type":"extras"},{"doc":"ValidationsIn ash, there are three kinds of validations.The simple allow_nil? and writable? validations provided for attributesType constraints, specific to each typeThe validations section","ref":"validation.html","title":"Validations","type":"extras"},{"doc":"These are considered simple/global enough to warrant being specified at the attribute level.attributes do attribute :some_field, :integer, writable?: false attribute :some_other_field, :integer, allow_nil?: false endTo see the equivalent statements using the validations section of a resource, see the corresponding section below.","ref":"validation.html#allow_nil-writable","title":"Validations - allow_nil/writable?","type":"extras"},{"doc":"Each type (including custom types) can expose constraints. When declaring an attribute these constraints can be provided with the constraints option. For example:attributes do attribute :some_field, :integer, constraints: [min: 1, max: 5] attribute :some_other_field, :string, constraints: [max_length: 255] end","ref":"validation.html#type-constraints","title":"Validations - Type constraints","type":"extras"},{"doc":"The validations section allows you to create validations based on the changeset. The only information available is the changeset. If you want to adjust the behavior based on other details of the request, like the current user, you are most likely looking for authorization.A validation is simply a module that implements the Ash.Resource.Validation behaviour. The built in validations expose utility functions that are imported into the resource's scope, to make them easier to read. You can do this with custom validations as well. See the documentation in Ash.Resource.Validation for more information. Right now, there are not very many built in validations, but the idea is that eventually we will have a rich library of built in validations to choose from.Validations can be scoped to the type (:create, :update, :destroy) of action (but not to specific actions). If you would like to adjust the validations for a specific action, that is (not yet, at the time of writing) supported by options on the action declaration.Important NoteBy default, validations run on create and update only. Many validations don't make sense in the context of deletes.Examplesvalidations do validate present([:foo, :bar]), on: :update validate present([:foo, :bar, :baz], at_least: 2), on: :create validate absent([:foo, :bar, :baz], exactly: 1), on: [:update, :destroy] validate {MyCustomValidation, [foo: :bar]}, on: :create end","ref":"validation.html#validations-section","title":"Validations - Validations Section","type":"extras"},{"doc":"Error HandlingError handling in Ash is still a work in progress, but the pattern is mostly formed at this point. There is a difficult balance to cut between informative errors and enabling simple reactions to those errors. Since many extensions may need to work with and/or adapt their behavior based on errors coming from Ash, we need rich error messages. However, when you have a hundred different exceptions to represent the various kinds of errors a system can produce, it becomes difficult to say something like &quot;try this code, and if it is invalid, do x, if it is forbidden, do y.","ref":"error_handling.html","title":"Error Handling","type":"extras"},{"doc":"To this effect, exceptions in Ash have one of four classes mapping to the top level exceptions:forbidden - Ash.Error.Forbiddeninvalid - Ash.Error.Invalidframework - Ash.Error.Frameworkunknown - Ash.Error.UnknownSince many actions can be happening at once, we want to support the presence of multiple errors as a result of a request to ash. We do this by grouping up the errors into one before returning or raising. We choose an exception based on the order of the exceptions listed above. If there is a single forbidden, we choose Ash.Error.Forbidden, if there is a single invalid, we choose Ash.Error.Invalid and so on. The actual errors will be included in the errors key on the exception. The exception's message will contain a bulleted list of all the underlying exceptions that occured. This makes it easy to react to specific kinds of errors, as well as to react to any/all of the errors present.An example of a single error being raised, representing multiple underlying errors:AshExample.Representative |&gt; Ash.Changeset.new(%{employee_id: &quot;dabes&quot;}) |&gt; AshExample.Api.create!() ** (Ash.Error.Invalid) Input Invalid * employee_id: must be absent. * first_name, last_name: at least 1 must be present. (ash 1.3.0) lib/ash/api/api.ex:534: Ash.Api.unwrap_or_raise!/1This allows easy rescuing of the major error classes, as well as inspection of the underlying casestry do AshExample.Representative |&gt; Ash.Changeset.new(%{employee_id: &quot;dabes&quot;}) |&gt; AshExample.Api.create!() rescue e in Ash.Error.Invalid -&gt; &quot;Encountered \#{Enum.count(e.errors)} errors&quot; end &quot;Encountered 2 errors&quot;This approach is relatively experimental. I haven't seen it done this way elsewhere, but it seems like a decent middle ground from a system that can generate multiple disparate errors on each pass.","ref":"error_handling.html#error-classes","title":"Error Handling - Error Classes","type":"extras"},{"doc":"AggregatesAggregates in Ash allow for retrieving summary information over groups of related data. A simple example might be to show the &quot;count of published posts for a user&quot;.","ref":"aggregates.html","title":"Aggregates","type":"extras"},{"doc":"Example: count :count_of_posts, :posts, filter: [published: true]See the documentation for the aggregates section in Ash.Resource.Dsl.aggregates/1 for more information.The aggregates declared on a resource allow for declaring a set of named aggregates that can be used by extensions. They can also be loaded in the query using Ash.Query.load/2, or after the fact using Ash.Api.load/2. Attributes declared on the resource will be keys in the resource's struct.","ref":"aggregates.html#declaring-aggregates-on-a-resource","title":"Aggregates - Declaring aggregates on a resource","type":"extras"},{"doc":"Example:User |&gt; Ash.Query.new() |&gt; Ash.Query.aggregate(:count_of_posts, :count, :posts, filter: [published: true])See the documentation for Ash.Query.aggregate/4 for more information.","ref":"aggregates.html#custom-aggregates-in-the-query","title":"Aggregates - Custom aggregates in the query","type":"extras"}]